# General

- [Overview](./overview.md)
- [Installation](./general/installation.md)
- [Getting started](./general/getting-started.md)

# `rudof` commands

`rudof` supports the following commands:

- [node](./cli_usage/node.md)
- [data](./cli_usage/data.md)
- [query](./cli_usage/sparql.md)
- [dctap](./cli_usage/dctap.md)
- [shex](./cli_usage/shex.md)
- [shacl](./cli_usage/shacl.md)
- [shapemap](./cli_usage/shapemap.md)
- [service](./cli_usage/service.md)
- [shex-validate](./cli_usage/shex_validate.md)
- [shacl-validate](./cli_usage/shacl_validate.md)
- [validate](./cli_usage/validate.md)
- [convert](./cli_usage/convert.md)

# `rudof` as a library

- [Docs](./library/docs.md)
- [Processing RDF](./library/rdf_processing.md)
- [Parsing RDF](./library/parsing_processing.md)
- [Python-bindings](./library/python.md)

# `rudof` internals

- [Scope of the project](./internals/scope.md)
- [Architecture](./internals/architecture.md)
- [ADRs](./internals/ADRs.md)

# More information

- [Benchmarks](./references/benchmarks.md)
- [FAQ](./references/faq.md)
